// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/Shader.hpp"

namespace Dawn {
  class SimpleBillboardedShader : public ShaderProgram {
    public:
      shaderparameter_t paramProjection;
      shaderparameter_t paramView;
      shaderparameter_t paramModel;
      shaderparameter_t paramColor;
      shaderparameter_t paramTexture;
      shaderparameter_t paramHasTexture;

      void compile() override;
  };

  class SimpleBillboardedShader : public Shader {
    public:
      SimpleBillboardedShaderProgram program;

      void compile() override;

      std::vector<struct ShaderPassItem> getPassItems(
        Mesh *mesh,
        Material *material,
        Camera *camera
      ) override;
  };
}