// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "scene/components/physics/2d/CharacterController2D.hpp"
#include "scene/components/PlayerController.hpp"
#include "scene/components/entity/EntityMove.hpp"

namespace Dawn {
  class EntityChargePlayer : public SceneItemComponent {
    protected:
      CharacterController2D *characterController = nullptr;
      EntityMove *entityMove = nullptr;

    public:
      EntityChargePlayer(SceneItem* item);
      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}