// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "EntityHealth.hpp"

using namespace Dawn;

EntityHealth::EntityHealth(SceneItem* item) : SceneItemComponent(item) {
  
}

void EntityHealth::onStart() {
  // Update
  useEvent([&](float_t delta){
    if(this->invincibleTime > 0.0f) {
      this->invincibleTime -= delta;
    }

    if(this->stunTime > 0.0f) {
      this->stunTime -= delta;
    }
  }, getScene()->eventSceneUpdate);

  
  // Hurt Hazard Processing
  // if(this->characterController != nullptr) {
  //   useEvent([&](struct CharacterController2DCollisionEventInfo info) {
  //     if(this->isInvincible()) return;

  //     auto hurtHazard = info.collider->item->getComponent<HurtHazard>();
  //     if(hurtHazard == nullptr) return;
  //     if(
  //       entityFaction != nullptr &&
  //       hurtHazard->faction == this->entityFaction->faction
  //     ) return;

  //     glm::vec2 back = glm::vec2(
  //       info.collider->transform->getLocalPosition().x,
  //       info.collider->transform->getLocalPosition().z
  //     ) - glm::vec2(
  //       this->transform->getLocalPosition().x,
  //       this->transform->getLocalPosition().z
  //     );

  //     this->characterController->velocity = back * -hitKnockback;
  //     this->damage({
  //       .amount = hurtHazard->damage
  //     });
  //   }, this->characterController->eventCollision);
  // }
}

bool_t EntityHealth::isInvincible() {
  return this->invincibleTime > 0.0f;
}

bool_t EntityHealth::isStunned() {
  return this->stunTime > 0.0f;
}

void EntityHealth::damage(struct DamageInformation info) {
  if(this->isInvincible()) return;
  this->health -= info.amount;
  this->invincibleTime = info.invincibleTime;
  this->stunTime = info.stunTime;
}